#include "ot4xb.ch"
#include "dll.ch"
#include "Appevent.ch"
// ---------------------------------------------------------------------------
#include "MyReceiverClassName.ch" // #define MY_RECEIVER_WND_CLASSNAME  UUID...
// ---------------------------------------------------------------------------
// Windows messages used in this sample
#define WM_COPYDATA                     0x004A
#define WM_CLOSE                        0x0010
#define WM_DESTROY                      0x0002
#define WM_NCDESTROY                    0x0082
// ---------------------------------------------------------------------------
static hWndReceiver   
// ---------------------------------------------------------------------------
// Templates for DLL functions
static _tfpRegisterClass_             := NIL
static _tfpUnRegisterClass_           := NIL
static _tfpCreateWindowEx_            := NIL
static _tfpDefWindowProc_             := NIL
static _tfpPostMessage_               := NIL
static _tfpSendMessage_               := NIL
static _tfpPostQuitMessage_           := NIL
static _tfpGetMessage_                := NIL
static _tfpDispatchMessage_           := NIL
static _tfpFindWindow_                := NIL
static _tfpSetForegroundWindow_       := NIL
// ---------------------------------------------------------------------------
BEGIN STRUCTURE WNDCLASS   // gwst subclass for manage WNDCLASS structures
    MEMBER UINT    style
    MEMBER LONG    lpfnWndProc
    MEMBER int     cbClsExtra
    MEMBER int     cbWndExtra
    MEMBER HANDLE  hInstance
    MEMBER HANDLE  hIcon
    MEMBER HANDLE  hCursor
    MEMBER HANDLE  hbrBackground
    MEMBER DYNSZ   lpszMenuName
    MEMBER DYNSZ   lpszClassName
END STRUCTURE
// ---------------------------------------------------------------------------
proc main(cParam)
local nEvent,oSle,mp1 := NIL,mp2 := NIL, oXbp := NIL
   SETCOLOR( "N/W" )
   CLS
   SingleInstance(cParam) // Check if another instance running
   
   nEvent := 0
   InitTheReceiver() // Start the receiver thread
   
   // Main Msg Loop
   while nEvent != xbeP_Close 
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      if nEvent ==  (xbeP_User + 1)    
         // Put the CRT and the exe in the foreground
         // see the explanation below on function ReceiverWndProc()
         DllExecuteCall( _tfpSetForegroundWindow_ , SetAppWindow():GetHwnd() )
      else
         oXbp:HandleEvent( nEvent, mp1, mp2 )
      end
   end
   KillTheReceiver() // Delete receiver window and his event loop
return
// ---------------------------------------------------------------------------
function SingleInstance(cParam)
local cClsName := MY_RECEIVER_WND_CLASSNAME 
local pData, pBuffer, hWnd
local nLen := 0        
hWnd := DllExecuteCall( _tfpFindWindow_ , @cClsName , 0)
if hWnd == 0                  
   if cParam != NIL
      SETCOLOR( "W/R" )
      ?? "Param: " , cParam
      SETCOLOR( "N/W" )
   end
else 
   if cParam == NIL ; cParam := "<NO PARAMS>" ; end
   pData   := _xgrab( 4 * 3 ) // Alloc memory for the COPYDATASTRUCT
   pBuffer := _xgrab( cParam , @nLen ) // Alloc memory and copy cParam
   // Fill the 3 DWORD members of the COPYDATASTRUCT {1,nLen,pBuffer}
   PokeDWord( pData , 0 , 1 , nLen , pBuffer ) 
   // Send the message to the receiver window
   
   DllExecuteCall( _tfpSendMessage_ , hWnd, WM_COPYDATA , 0, pData )
   // Release heap memory for pData and pBuffer
   _xfree( pBuffer )
   _xfree( pData )
   QUIT  // Existing instance is now on the foreground
         // so we can quit this instance
end
return NIL
// ---------------------------------------------------------------------------
init proc _PrepareDllImportFunctions_()
// Get the import templates for user32.dll functions used in this sample
_tfpFindWindow_          := DllPrepareCall(GetHUser32(),DLL_STDCALL,"FindWindowA")
_tfpPostMessage_         := DllPrepareCall(GetHUser32(),DLL_STDCALL,"PostMessageA")
_tfpSendMessage_         := DllPrepareCall(GetHUser32(),DLL_STDCALL,"SendMessageA")
_tfpRegisterClass_       := DllPrepareCall(GetHUser32(),DLL_STDCALL,"RegisterClassA")
_tfpUnRegisterClass_     := DllPrepareCall(GetHUser32(),DLL_STDCALL,"UnregisterClassA")
_tfpCreateWindowEx_      := DllPrepareCall(GetHUser32(),DLL_STDCALL,"CreateWindowExA")
_tfpDefWindowProc_       := DllPrepareCall(GetHUser32(),DLL_STDCALL,"DefWindowProcA")
_tfpPostQuitMessage_     := DllPrepareCall(GetHUser32(),DLL_STDCALL,"PostQuitMessage")
_tfpGetMessage_          := DllPrepareCall(GetHUser32(),DLL_STDCALL,"GetMessageA")
_tfpDispatchMessage_     := DllPrepareCall(GetHUser32(),DLL_STDCALL,"DispatchMessageA")
_tfpSetForegroundWindow_ := DllPrepareCall(GetHUser32(),DLL_STDCALL,"SetForegroundWindow")
return
// ---------------------------------------------------------------------------
// The receiver window will run in it's own thread
function InitTheReceiver()
local oThread
oThread := Thread():New()
oThread:Start({||ReceiverThread()})
return NIL
// ---------------------------------------------------------------------------
function ReceiverThread()
local pMsg
local oCls := WNDCLASS():New() // WNDCLASS gwst structure object
local hReceiverClass // Class Handle of the receiver window

oCls:lpfnWndProc   := _callback_ReceiverWndProc() // xppcbk ReceiverWndProc.cbk -> .obj
oCls:hInstance     := AppInstance()  // Instance handle of the EXE 
oCls:lpszClassName := MY_RECEIVER_WND_CLASSNAME // autogenerated with UUIDGen.exe
hReceiverClass  := LoWord(DllExecuteCall( _tfpRegisterClass_ , oCls:_lock_() ))
oCls:_unlock_()  // release structure memory and copy content to a character buffer
oCls:lpszClassName := NIL // free dynamic heap memory for the DYNSZ member

hWndReceiver := DllExecuteCall( _tfpCreateWindowEx_ ,;
                                 0 ,; // No exStyle
                                 hReceiverClass,;// Window Class handle
                                 0,; // No Title
                                 0xC40000,; // dwStyle WS_OVERLAPED
                                 0,0,0,0,; // x,y,cx,cy
                                 0,; // hWndParent 
                                 0,; // hMenu
                                 AppInstance(),;
                                 0) // empty LPParam

pMsg := _xgrab(32) // Allocate memory for MSG structure 
                   // Note: If we need to manipulate the MSG members 
                   // the easy way can be create a gwst class 
                   // like in the WNDCLASS case to manipulate 
                   // the members. But in this case we just need to 
                   // provide a buffer to hold the MSG and pass 
                   // it to DispatchMessage(), so just allocate 
                   // sufficient memory to hold the entire MSG
                   // structure.

// Thread message loop
while DllExecuteCall( _tfpGetMessage_ , pMsg , 0 , 0 , 0 ) != 0
   // TranslateMessage(pMsg) not needed because keyb/mouse input will not be processed here.
   DllExecuteCall( _tfpDispatchMessage_ , pMsg )
end
_xfree( pMsg)  // free heap memory 
// At this point the receiver window must not exist so we can unregiter the class
MsgBox( Str( DllExecuteCall( _tfpUnRegisterClass_ , hReceiverClass , AppInstance() ) ))
return NIL
// ---------------------------------------------------------------------------
function KillTheReceiver()
   // Called from the main thread
   DllExecuteCall( _tfpPostMessage_ , hWndReceiver , WM_CLOSE, 0, 0)
return NIL
// ---------------------------------------------------------------------------
// Callback function implementation
// xppcbk.exe compiler will create a STDCALL proxi funcion
// from the script file ReceiverWndProc.cbk and produce 
// the ReceiverWndProc.obj file that we need to add to our prj
// We can retrieve a pointer to the proxi STDCALL function
// from our prg calling _callback_ReceiverWndProc()
// ( "_callback_" + XbaseFunctionName )
// so only rest to implement our public Xbase++ function here.
// This will be our window proc.
 
function ReceiverWndProc( hWnd , nMsg , wp , lp )
local aData                                          

if( nMsg == WM_COPYDATA )
   // lp will provide us a pointer to a COPYDATASTRUCT structure
   // again instead of use a gwst structure class we can see how
   // to manipulate simple and small structures directly 
   //  typedef struct tagCOPYDATASTRUCT {
   //       ULONG_PTR dwData;  // aData[1] Command ID
   //       DWORD cbData;      // aData[2] Len() of the data
   //       PVOID lpData;      // aData[3] Pointer to the buffer
   //    } COPYDATASTRUCT, *PCOPYDATASTRUCT;
   // PeekDWord( pBuffer , nShift , nDWORDs ) -> aDWords  
   aData := PeekDWord( lp , 0 , 3 )
   if aData[1] == 1 
      // We are using here the command 1 to receive params from new instances
      // of this exe
      SETCOLOR( "W/R" )
      ? "New Instance: " ,  PeekStr( aData[3] , 0 , aData[2] )
      SETCOLOR( "N/W" )    
     // SetForegroundWindow()  not always work from external threads of 
     // the destination window so we post a custom Xbase++ event and call
     // SetForegroundWindow() from the CRT main loop
     PostAppEvent(xbeP_User + 1 ,0,0,SetAppWindow())

   elseif aData[1] == 0
      // We are using here the command 0 to receive strings from sender.exe 
      ? PeekStr( aData[3] , 0 , aData[2] )
   end
   return 1  // Message dispatched
elseif nMsg == WM_CLOSE
   // Destroy the receiver window
   DllExecuteCall( _tfpPostMessage_ , hWnd, WM_DESTROY , 0, 0)
   DllExecuteCall( _tfpPostMessage_ , hWnd, WM_NCDESTROY, 0, 0)
   return 1
elseif nMsg == WM_NCDESTROY
   // end the receiver thread
   DllExecuteCall( _tfpPostQuitMessage_ , 1)
   // let DefWindowProc() to destroy our window
end
// DefWindowProc() will process the rest of the cases
return DllExecuteCall( _tfpDefWindowProc_ , hWnd , nMsg , wp , lp )
// ---------------------------------------------------------------------------

